import { EVMAccountAddress, EVMContractAddress, MinimalForwarderContractError, BigNumberString, Signature, BlockchainCommonErrors } from "@snickerdoodlelabs/objects";
import { ethers } from "ethers";
import { ResultAsync } from "neverthrow";
import { BaseContract } from "../implementations/BaseContract.js";
import { IEthersContractError } from "../implementations/BlockchainErrorMapper";
import { ContractOverrides, IMinimalForwarderContract, IMinimalForwarderRequest, WrappedTransactionResponse } from "../interfaces/index.js";
export declare class MinimalForwarderContract extends BaseContract<MinimalForwarderContractError> implements IMinimalForwarderContract {
    protected providerOrSigner: ethers.providers.Provider | ethers.providers.JsonRpcSigner | ethers.Wallet;
    protected contractAddress: EVMContractAddress;
    constructor(providerOrSigner: ethers.providers.Provider | ethers.providers.JsonRpcSigner | ethers.Wallet, contractAddress: EVMContractAddress);
    getContractAddress(): EVMContractAddress;
    getNonce(from: EVMAccountAddress): ResultAsync<BigNumberString, MinimalForwarderContractError | BlockchainCommonErrors>;
    verify(request: IMinimalForwarderRequest, signature: Signature): ResultAsync<boolean, MinimalForwarderContractError | BlockchainCommonErrors>;
    execute(request: IMinimalForwarderRequest, signature: Signature, overrides?: ContractOverrides): ResultAsync<WrappedTransactionResponse, BlockchainCommonErrors | MinimalForwarderContractError>;
    protected generateContractSpecificError(msg: string, e: IEthersContractError, transaction: ethers.Transaction | null): MinimalForwarderContractError;
}
//# sourceMappingURL=MinimalForwarderContract.d.ts.map